function [param1,param2,param3,param4,param5,param6,out1]= ...
  GoSimControl(param1,param2,param3,param4,param5,param6,...
  i,h,stop,count,sn,in1)
  

%från GoSim i första sampeln:  
%param1 = täljare för systemet som ska styras
%param2 = nämnare för systemet som ska styras
%param3 = antal poler i lågpassfiltret, n
%param4 = b,  L=1/(s+b)^n*b^n
%param5 = 0 (tom)
%param6 = 0 , flagga för om parametrarna ändras eller ej, 
%används för errorkoll

%parametrar som itereras i loopen från denna funktion: 
%param1 är A
%param2 är B
%param3 är C
%param4 är D
%param5 är states
%param6 = 1

%denna funktion använder alltid Euler backward som lösare

%parametrarna ändras efter första sampeln
num_sys=param1;
den_sys=param2;
n=param3;
b=param4;

%antal poler måste vara minst skillnaden i grad mellan täljare
%och nämnare i sys som ska styras
if(length(den_sys)-length(num_sys)>n && param6==0)
  disp("Non realizable, increase number of poles. Output set to 0.");
  out1=0;
elseif(b<=0 && param6==0)
  disp("b must be >0. Output set to 0.");
  out1=0;
elseif( (n<1 || mod(n,1)!=0) && param6==0)%n måste vara heltal och >0
  disp("n must be >0 and an integer. Output set to 0.");
  out1=0;
else
  if(count==1)
    %räknar ut regulatorn
    pkg load control;
    s=tf('s');
    L=1/(s+b)^n*b^n;
    sys=tf(num_sys,den_sys);
    Z=L/(1-L)/sys;%regulatorn
    
    sys=ss(Z);
    A=sys.a;
    B=sys.b;
    C=sys.c;
    D=sys.d;
    states=zeros(length(A),1);
    
    
    %Euler backward, denna är bäst
    L=length(A);
    temp=(eye(L)-A*h)^-1;
    A=temp;
    B=temp*B*h;
    
    param1 = A;
    param2 = B;
    param3 = C;
    param4 = D;
    param5 = states;
    param6=1;
    
  end
  
  %räknar ut state space-ekvationerna, som är diskretiserade.
  %detta görs i alla iterationer
  
  A = param1;
  B = param2;
  C = param3;
  D = param4;
  states = param5;
  
  %Euler backward, denna är bäst
  states=A*states+B*in1;
  out1=C*states+D*in1;%efter states räknats ut!!
  param5=states;
  
  
end
