function [param1,param2,param3,param4,param5,param6,param7,...
  param8,out1]= TransferFunction(param1,param2,param3,param4,...
  param5,param6,param7,param8,i,h,stop,count,sn,in1)
  
%överf.funktion
%parametrar från GoSim i första sampeln:
%param1 är täljare (numerator)
%param2 är nämnare (denominator)
%param3 är solver method
%param4 är tom (0)
%param5 är tom (0)
%param6 är tom (0)
%param7 är tom (0)
%param8 = 0, flagga för om parametrarna ändras, för att
%errorkoll ska fungera efter första sampeln

%parametrar som itereras i loopen från denna funktion: 
%gäller ej om användaren väljer konstant som ö-fkn. eller om det
%blir error
%param1 är A
%param2 är B
%param3 är C
%param4 är D
%param5 är states
%param6 är u(k-1), alltså in1 från förra samplen, används för
%tustins metod
%param7 är solver method
%param8 = 1;

%euler backward ger bäst resultat vid gränsen till instabilitet
%ZOH ger bäst resultat när systemet är stabilt

numerator=param1;
denominator=param2;


%algoritmen fungerar bara för proper transfer function
if ( length(numerator) > length(denominator) && param8==0 )
  disp([sn " Error: not proper transfer function, output set to 0."]);
  out1=0;
%om första värdet i nämnaren är 0 ger det inf när alla
%koefficienter delas med den eftersom den ska vara 1.
%ger errormedd. och 0 sätts ut
elseif(denominator(1)==0)
  disp([sn " Error: first coefficient in denominator can't be 0, output set to 0."]);
  out1=0;  
%om det är en konstant fungerar inte konvertingen till
%state space nedan, så behandlar det separat
elseif (length(denominator) ==1 && param8==0)

  out1=numerator/denominator*in1;
  param1=numerator;
  param2=denominator;
  
else
  %skapar tillståndsmatriserna A,B,C,D vid första iterationen
  if (count==1)
     param8=1;%flagga för att parametrar ändras
    
     %vid första iterationen måste states få rätt längd, och satt till 0
     states=( zeros(length(denominator)-1,1 )  );
     
     param5 = states;

     
    %koefficienten till högsta graden i nämnaren måste vara 1
    if(denominator(1)!=1)
      numerator=numerator./denominator(1);%numerator först eftersom denom ändrar sig själv
      denominator=denominator./denominator(1);
    end
  
    %antalet element i täljaren måste vara lika många som i
    %nämnaren även om det är färre koeff i ekvationen, de 
    %sätts till noll
    while( length(numerator)<=length(denominator)-1  )
      numerator=[0 numerator];
    end
  
    %skapar systemmatriserna
    %controllable canonical form
    n=length(denominator)-2;
    l=length(denominator);
    A=[zeros(n,1) eye(n);  denominator(l:-1:2)*-1];
    B=zeros(length(denominator)-1, 1 );
    B(length(B)) = 1;
    C=numerator(l:-1:2)-denominator(l:-1:2).*numerator(1);
    D=numerator(1);
  
  %observable canonical form, fungerar och ger exakt
  %samma resultat som controllable canonical
%  A=[ [zeros(1,n) ; eye(n) ]  -denominator(l:-1:2)' ];
%  B=C';
%  C=[zeros(1,n) 1];
%  D=numerator(1);

    

    
    
    
  
%  %octave control, fungerar också, med exakt
% samma resultat som ovan, ej anpassad till nya metoden
%  pkg load control
%  %numerator
%  %denominator
%  sys=ss(tf([numerator],[denominator],h));
%  A=sys.a;
%  B=sys.b;
%  C=sys.c;
%  D=sys.d;
%  if (count==1)
%    states=zeros(length(A),1);
%  end

    param7 = param3;%solver method byter plats

    %zero-order hold
    if(param7==1)
      L=length(A);
      A1=eye(L)+A*h;
      B1=eye(L)*h;
      for i = 2:50
        A1=A1+A^i*h^i/factorial(i);
        B1=B1+A^(i-1)*h^i/factorial(i);
      end
      A=A1;
      B=B1*B;
    end
    
    
    %Euler backward, denna är bäst
    if(param7==3)
      L=length(A);
      temp=(eye(L)-A*h)^-1;
      A=temp;
      B=temp*B*h;
    end
    
    
    %Tustins metod
    if(param7==4)
      param6=in1;
      L=length(A);
      A=(eye(L)-A*h/2)^-1*(eye(L)+A*h/2);
      B=(eye(L)-A*h/2)^-1*B*h/2;
    end
    
    
    param1 = A;
    param2 = B;
    param3 = C;
    param4 = D;
    
    
  end
  
  %räknar ut state space-ekvationerna, som är diskretiserade.
  %detta görs i alla iterationer
  
  A = param1;
  B = param2;
  C = param3;
  D = param4;
  states = param5;
  
  
  %ZOH
  if(param7==1)
    out1=C*states+D*in1;
    states=A*states+B*in1;
    param5=states;
  end
  
  %Euler forward:
  if(param7==2)
    out1=C*states+D*in1;
    states=(A*states+B*in1)*h+states;
    param5=states;
  end
  
  %Euler backward, denna är bäst
  if(param7==3)
    states=A*states+B*in1;
    out1=C*states+D*in1;%efter states räknats ut!!
    param5=states;
  end
  
  
  %Tustins metod
  if(param7==4)
    states=A*states+B*(in1+param6);
    out1=C*states+D*in1;%efter states räknats ut!!
    param5=states;
    param6=in1;
  end
  
  
  %ode45
  if(param7==5)
    funk = @(T,Y) A*Y+B*in1;
    [T,Y] = ode45 (funk, [i, i+h], states);
  %length(A)
  %Y
  %T
  %states=Y(T==i+h,:)';%metod om man vill köra flera punkter
    states=Y(length(Y),:)';
    out1=C*states+D*in1;%efter states räknats ut ger mkt bättre resultat
    param5=states;
  end
  
  
  
end